package com.displaynone.acss.components.acs.models.gate.repository

import android.util.Log
import com.displaynone.acss.config.Constants.serverUrl
import com.displaynone.acss.config.Network
import io.ktor.client.call.body
import io.ktor.client.request.headers
import io.ktor.client.request.patch
import io.ktor.client.request.post
import io.ktor.client.request.setBody
import io.ktor.client.statement.bodyAsText
import io.ktor.http.ContentType
import io.ktor.http.HttpHeaders
import io.ktor.http.HttpStatusCode
import io.ktor.http.contentType
import kotlinx.coroutines.Dispatchers
import kotlinx.coroutines.withContext

class GateRepository {

    suspend fun openDoor(token: String, code: String): Result<Int> = withContext(Dispatchers.IO){
        runCatching{
            val result = Network.client.post("$serverUrl/api/acs/open") {
                headers {
                    append(HttpHeaders.Authorization, "Bearer $token")
                }
                contentType(ContentType.Application.Json)
                setBody("""{ "code": $code, "visitType": "APP" }""")
            }
            if (result.status != HttpStatusCode.OK) {
                error("Status ${result.status}: ${result.body<String>()}")
            }
            Log.d("UserRepository", result.bodyAsText())
            result.status.value
        }
    }
}